/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.benutzerverwaltung.boundary;

import de.ivu.elect.business.benutzerverwaltung.entity.Benutzer;

@javax.enterprise.context.ApplicationScoped // ELECT-7845
public class BenutzerDAO extends AbstractBenutzerDAO {

  private static final long serialVersionUID = 1L;

  @javax.inject.Inject
  private transient de.ivu.elect.jee.entity.SimpleDAO simpleDAO;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return simpleDAO.getEntityManager();
  }

  public void persist(Benutzer benutzer){
    getEntityManager().persist(benutzer);
  }

  public void remove(Benutzer benutzer){
    getEntityManager().remove(benutzer);
  }

@javax.inject.Inject
private transient de.ivu.elect.presentation.system.DAOCache daoCache;

                    
        /**
        * Name: AllNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT o FROM Benutzer o WHERE o.mandant=?1<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<Benutzer> findByAll( @javax.annotation.Nonnull de.ivu.elect.business.mandant.entity.Mandant mandant) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Benutzer.findByAll" ,  mandant  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByAll( mandant  ));
        }
        return (java.util.List<Benutzer>) cached;
        }
            return super.findByAll( mandant  );
            }
                                        
        /**
        * Name: AllOrderByBenutzerkennungNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT o FROM Benutzer o WHERE o.mandant=?1 ORDER BY o.benutzerkennung<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<Benutzer> findByAllOrderByBenutzerkennung( @javax.annotation.Nonnull de.ivu.elect.business.mandant.entity.Mandant mandant) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Benutzer.findByAllOrderByBenutzerkennung" ,  mandant  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByAllOrderByBenutzerkennung( mandant  ));
        }
        return (java.util.List<Benutzer>) cached;
        }
            return super.findByAllOrderByBenutzerkennung( mandant  );
            }
                                        
        /**
        * Name: BenutzerkennungUpperNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT o FROM Benutzer o WHERE UPPER(o.benutzerkennung) = UPPER(?2) AND o.mandant = ?1<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<Benutzer> findByBenutzerkennungUpper( @javax.annotation.Nonnull de.ivu.elect.business.mandant.entity.Mandant mandant,  @javax.annotation.Nonnull String benutzerkennung) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Benutzer.findByBenutzerkennungUpper" ,  mandant ,  benutzerkennung  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByBenutzerkennungUpper( mandant ,  benutzerkennung  ));
        }
        return (java.util.List<Benutzer>) cached;
        }
            return super.findByBenutzerkennungUpper( mandant ,  benutzerkennung  );
            }
                        
@Override
public void clear() {
super.clear();
if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
daoCache.clear();
}

}

@Override
public void flush() {
super.flush();
if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
daoCache.clear();
}
}



}